# encoding: UTF-8
# fakultaet.py

__all__ = ['fakultaet']


def fakultaet(n, fehlertext=u"Argument %s ungültig!"):
    """Gib die Fakultät des Arguments n zurück.

    Optional kann man als zweites Argument einen Fehlertext
    angeben, der als Platzhalter für das ungültige Argument
    %r oder %s enthalten muss.
    """
    if n < 0:
        kompletter_fehlertext = fehlertext % n
        if isinstance(kompletter_fehlertext, unicode):
            kompletter_fehlertext = kompletter_fehlertext.encode("UTF-8")
        raise ValueError(kompletter_fehlertext)
    fakultaet = 1
    for i in xrange(1, n+1):
        fakultaet *= i
    return fakultaet
